
Redmine - Defect #677

Unable to delete role

2008-02-16 21:45 - Sven Schuchmann

Status: Closed Start date: 2008-02-16

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Administration Estimated time: 0.00 hour

Target version:    

Resolution: Fixed Affected version:  

Description

Hi,

i just tried to delete the reporter role

with r1146.

but i get an "internal error".

log says:

Processing RolesController#destroy (for 10.158.151.2 at 2008-02-16 21:34:55) [POST]

  Session ID: e25ff3d99be777a81a0bb7825d28da6a

  Parameters: {"action"=>"destroy", "id"=>"8", "controller"=>"roles"}

  SQL (0.000247)   SELECT max(updated_on) AS max_updated_on FROM settings 

  User Load (0.000223)   SELECT * FROM users WHERE (status = 1) AND (users.`id` = 1) 

  Role Load (0.000146)   SELECT * FROM roles WHERE (roles.`id` = 8) 

  SQL (0.000036)   BEGIN

  Member Load (0.000165)   SELECT * FROM members WHERE (members.role_id = 8) 

  SQL (0.000055)   ROLLBACK

RuntimeError (Can't delete role):

    /app/models/role.rb:105:in `check_deletable'

    /usr/lib/ruby/gems/1.8/gems/activerecord-1.15.3/lib/active_record/callbacks.rb:333:in `send'

    /usr/lib/ruby/gems/1.8/gems/activerecord-1.15.3/lib/active_record/callbacks.rb:333:in `callbac

k'

    /usr/lib/ruby/gems/1.8/gems/activerecord-1.15.3/lib/active_record/callbacks.rb:330:in `each'

    /usr/lib/ruby/gems/1.8/gems/activerecord-1.15.3/lib/active_record/callbacks.rb:330:in `callbac

k'

    /usr/lib/ruby/gems/1.8/gems/activerecord-1.15.3/lib/active_record/callbacks.rb:320:in `destroy

_without_transactions'

    /usr/lib/ruby/gems/1.8/gems/activerecord-1.15.3/lib/active_record/transactions.rb:125:in `dest

roy'

    /usr/lib/ruby/gems/1.8/gems/activerecord-1.15.3/lib/active_record/connection_adapters/abstract

/database_statements.rb:59:in `transaction'

    /usr/lib/ruby/gems/1.8/gems/activerecord-1.15.3/lib/active_record/transactions.rb:95:in `trans

action'

    /usr/lib/ruby/gems/1.8/gems/activerecord-1.15.3/lib/active_record/transactions.rb:121:in `tran

saction'

    /usr/lib/ruby/gems/1.8/gems/activerecord-1.15.3/lib/active_record/transactions.rb:125:in `dest

roy'

    /app/controllers/roles_controller.rb:59:in `destroy'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/base.rb:1095:in `send'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/base.rb:1095:in `perform_a

ction_without_filters'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:632:in `call_fi

lter'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:638:in `call_fi

lter'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:438:in `call'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:637:in `call_fi

lter'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:638:in `call_fi

lter'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:438:in `call'
    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:637:in `call_fi

lter'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:638:in `call_fi

lter'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:438:in `call'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:637:in `call_fi

lter'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:638:in `call_fi

lter'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:438:in `call'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:637:in `call_fi

lter'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:638:in `call_fi

lter'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:438:in `call'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:637:in `call_fi

lter'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:619:in `perform

_action_without_benchmark'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/benchmarking.rb:66:in `per

form_action_without_rescue'

    /usr/lib/ruby/1.8/benchmark.rb:293:in `measure'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/benchmarking.rb:66:in `per

form_action_without_rescue'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/rescue.rb:83:in `perform_a

ction'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/base.rb:430:in `send'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/base.rb:430:in `process_wi

thout_filters'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/filters.rb:624:in `process

_without_session_management_support'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/session_management.rb:114:

in `process'

    /usr/lib/ruby/gems/1.8/gems/actionpack-1.13.3/lib/action_controller/base.rb:330:in `process'

    /usr/lib/ruby/gems/1.8/gems/rails-1.2.3/lib/dispatcher.rb:41:in `dispatch'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/lib/mongrel/rails.rb:78:in `process'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/lib/mongrel/rails.rb:76:in `synchronize'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/lib/mongrel/rails.rb:76:in `process'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/lib/mongrel.rb:618:in `process_client'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/lib/mongrel.rb:617:in `each'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/lib/mongrel.rb:617:in `process_client'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/lib/mongrel.rb:736:in `run'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/lib/mongrel.rb:736:in `initialize'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/lib/mongrel.rb:736:in `new'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/lib/mongrel.rb:736:in `run'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/lib/mongrel.rb:720:in `initialize'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/lib/mongrel.rb:720:in `new'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/lib/mongrel.rb:720:in `run'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/lib/mongrel/configurator.rb:271:in `run'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/lib/mongrel/configurator.rb:270:in `each'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/lib/mongrel/configurator.rb:270:in `run'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/bin/mongrel_rails:127:in `run'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/lib/mongrel/command.rb:211:in `run'

    /usr/lib/ruby/gems/1.8/gems/mongrel-1.0.1/bin/mongrel_rails:243

    /usr/bin/mongrel_rails:16:in `load'

    /usr/bin/mongrel_rails:16

History

#1 - 2008-02-16 22:09 - Jean-Philippe Lang

- Status changed from New to Closed

- Resolution set to Fixed

You were trying to delete a role that is in use.

Fixed in r1159. A proper error message is now displayed instead of the internal error.
If you want to delete the role, make sure that it's not assigned to any member.

#2 - 2008-02-17 10:04 - Sven Schuchmann

- Status changed from Closed to Reopened

Okay, I checked this with r1160 and now I receive:

"This role is in use and can not be deleted."

I double-checked all of my Projects (3 in common)

but no one is assigned to the reporter role?

#3 - 2008-02-17 12:05 - Jean-Philippe Lang

Did you look at the locked users ? Their memberships don't appear when looking at the projects.

I'm pretty sure that you have a locked user with this role on some project.

I agree that it can be confusing.

Being able to remove a role and automatically reassign users to another role would be a better solution.

#4 - 2008-02-17 12:41 - Sven Schuchmann

I think a better solution would be to get a list of

users which still belong to this role if you want to

delete the role.

I will check my users tomorrow and update this ticket.

#5 - 2008-02-17 19:02 - Sven Schuchmann

You were right, there was a locked user which had the role "reporter".

After I deleted his membership I was able to delete the role.

You can close the ticket! (or you want to keep

it open for a better solution)

Thanks!

#6 - 2008-02-18 19:40 - Jean-Philippe Lang

- Status changed from Reopened to Resolved

#7 - 2008-06-08 15:36 - Thomas Lecavelier

- Status changed from Resolved to Closed

Resolved two monthes ago without activity: closed.
